function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.switchtimer = Timer();
	self.targettimer = Timer();
	self.fueltimer = Timer();
	self.didswitch = false;
	self.parentplayer = 0;
	self.currentfuel = 0;

	self.switchtime = 500;
	self.targetchecktime = 100;
	self.detectrange = 400;
	self.switchondestroy = true;
	self.missilefuel = 100;

	self.curdist = 50;
	for i = 1,MovableMan:GetMOIDCount()-1 do
		self.gun = MovableMan:GetMOFromID(i);
		if self.gun.PresetName == "GML" and self.gun.ClassName == "HDFirearm" and SceneMan:ShortestDistance(self.Pos,self.gun.Pos,self.mapwrapx).Magnitude < self.curdist then
			self.actor = MovableMan:GetMOFromID(self.gun.RootID);
			if MovableMan:IsActor(self.actor) then
				self.parent = ToActor(self.actor);
				self.parentgun = ToHDFirearm(self.gun);
				self.currentfuel = self.missilefuel;
				self.Vel = self.parent.Vel + Vector(10,0):RadRotate(self.parent:GetAimAngle(true));
				self.RotAngle = self.parent:GetAimAngle(true);
			end
		end
	end

end

function Update(self)

	if MovableMan:IsActor(self.parent) and self.parent:HasObject("GML") then

		if self.fueltimer:IsPastSimMS(100) then
			self.fueltimer:Reset();
			self.currentfuel = self.currentfuel - 1;
		end

		if self.currentfuel <= 0 then
			self:GibThis();
		end

		if self.didswitch == false then

			if not(self.switchtimer:IsPastSimMS(self.switchtime)) then
				if self.parent:GetController():IsState(Controller.PIE_MENU_ACTIVE) and self.parent:IsPlayerControlled() == true then

					self.controller = CreateACrab("GML Control","GML.rte");
					self.controller.Team = self.parent.Team;
					self.controller.Pos = self.Pos;
					self.controller.HFlipped = self.parent.HFlipped;
					self.controller:SetAimAngle(self.parent:GetAimAngle(false))
					MovableMan:AddActor(self.controller);

					self.parentplayer = self.parent:GetController().Player;
					ActivityMan:GetActivity():SwitchToActor(self.controller,self.parentplayer,self.parent.Team);

					self.didswitch = true;

				end
			else

				if MovableMan:IsActor(self.target) then
					self.RotAngle = SceneMan:ShortestDistance(self.Pos,self.target.Pos,self.mapwrapx).AbsRadAngle;
				elseif not(MovableMan:IsActor(self.target)) and self.targettimer:IsPastSimMS(self.targetchecktime) then
					self.targettimer:Reset();

					for actor in MovableMan.Actors do
						if actor.ID ~= self.parent.ID and actor.Team ~= self.parent.Team then
							self.potentialtargetdist = SceneMan:ShortestDistance(self.Pos,actor.Pos,self.mapwrapx);
							self.terrcheck = Vector(0,0);
							if (self.lastdist == nil or (self.lastdist ~= nil and self.potentialtargetdist.Magnitude < self.lastdist)) and self.potentialtargetdist.Magnitude <= self.detectrange and SceneMan:CastStrengthRay(self.Pos,self.potentialtargetdist:SetMagnitude(self.potentialtargetdist.Magnitude-actor.Radius),0,self.terrcheck,5,0,self.mapwrapx) == false then
								self.lastdist = self.potentialtargetdist.Magnitude;
								self.target = actor;
							end
						end
					end

					if MovableMan:IsActor(self.target) then
						self.targetsound = CreateAEmitter("GML Sound Target","GML.rte");
						self.targetsound.Pos = self.Pos;
						MovableMan:AddParticle(self.targetsound);
					end

				end

			end

		elseif self.didswitch == true then

			if MovableMan:IsActor(self.controller) then

				if self.controller:IsPlayerControlled() == true then

					self.controller.Health = self.currentfuel;
					self.controller.Pos = self.Pos;
					self.RotAngle = self.controller:GetAimAngle(true);

					if self.controller:GetController():IsState(Controller.WEAPON_FIRE) then
						if self.switchondestroy == true then
							ActivityMan:GetActivity():SwitchToActor(self.parent,self.parentplayer,self.parent.Team);
						end
						self:GibThis();
						self.controller.ToDelete = true;
					end

					if self.controller:GetController():IsState(Controller.BODY_CROUCH) then
						self.didswitch = false;
						ActivityMan:GetActivity():SwitchToActor(self.parent,self.parentplayer,self.parent.Team);
						self.controller.ToDelete = true;
					end

				else
					self.didswitch = false;
					self.controller.ToDelete = true;
				end

			else
				self:GibThis();
			end

		end

	else
		self:GibThis();
	end

end

function Destroy(self)

	if MovableMan:IsActor(self.controller) then
		if MovableMan:IsActor(self.parent) and self.switchondestroy == true then
			ActivityMan:GetActivity():SwitchToActor(self.parent,self.parentplayer,self.parent.Team);
			print("missile switch worked");
		end
		self.controller.ToDelete = true;
	end

end